From 4f7e6fa1f55866d131cfc8d685ceb267febac237 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:09 +0000
Subject: [PATCH 374/2232] Fix align of CxxVector


A vector whose element type is highly aligned need not itself be highly
aligned. If C++ passed in a reference to a vector which is less aligned
than its element type, and Rust thought vectors were more highly aligned
then they really are, then that would have been undefined behavior.

---

diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index feb2e29..6cf927b 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -1,3 +1,5 @@
+use std::mem;
+
 pub trait VectorTarget<T> {
     fn get_unchecked(v: &CxxVector<T>, pos: usize) -> &T
     where
@@ -20,7 +22,7 @@ pub trait VectorTarget<T> {
 /// compatible with Rust's move behavior. Instead in Rust code we will only ever
 /// look at a Vector through a reference or smart pointer, as in `&Vector`
 /// or `UniquePtr<Vector>`.
-#[repr(C)]
+#[repr(C, packed)]
 pub struct CxxVector<T> {
     _private: [T; 0],
 }
@@ -90,3 +92,5 @@ cxxbridge_macro::vector_builtin!(i64);
 cxxbridge_macro::vector_builtin!(isize);
 cxxbridge_macro::vector_builtin!(f32);
 cxxbridge_macro::vector_builtin!(f64);
+
+const_assert_eq!(1, mem::align_of::<CxxVector<usize>>());

